/*******************************************************************
*
*  DESCRIPTION: Atomic Model for Controller1
*
*  AUTHOR: Yuri Boiko
*
*  EMAIL: yuri.boiko@rocketmail.com
*
*  DATE: 27/10/2007
*
*******************************************************************/

#ifndef CONTROLLER1_H
#define CONTROLLER1_H

#include "atomic.h"

class Controller1 : public Atomic
{
public:
	Controller1( const string &name = "Controller1" );
	~Controller1();

	virtual string className() const { return "Controller1"; }

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &m1_in, &m1_inCount;
	const Port &m1_outFire, &m1_outOff;
	Time cycleTime;
	int count;
};

#endif   //CONTROLLER1_H
