/*******************************************************************
*
*  DESCRIPTION: Atomic Model for Controller2 for time slot [9,12]
*
*  AUTHOR: Yuri Boiko
*
*  EMAIL: yuri.boiko@rocketmail.com
*
*  DATE: 27/12/2007
*
*******************************************************************/

#ifndef CONTROLLER2_H
#define CONTROLLER2_H

#include "atomic.h"

class Controller2 : public Atomic
{
public:
	Controller2( const string &name = "Controller2" );
	~Controller2();

	virtual string className() const { return "Controller2"; }

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &m2_in, &m2_inCount;
	const Port &m2_outFire, &m2_outOff;
	Time cycleTime;
	int count;
};

#endif   //CONTROLLER2_H
