/*******************************************************************
*
*  DESCRIPTION: Coupled Model of Spiking Neuron Decoder
* Consisting of Spike Supplier with Block of Amplifiers amp_1 and amp_2
* and Spiking Neuron, which in turn include Timer and Controller
*
*  AUTHOR: Yuri Boiko
*
*  EMAIL: yuri.boiko@rocketmail.com
*
*  DATE: 27/12/2007
*
*******************************************************************/

#include "modeladm.h" 
#include "mainsimu.h"
#include "amp_1.h"	// class Amplifier 1
#include "amp_2.h"	// class Amplifier 2
#include "timer.h"
#include "timer1.h"
#include "timer2.h"
#include "controller.h"
#include "controller1.h"
#include "controller2.h"

void MainSimulator::registerNewAtomics()
{
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Amp_1>() , "Amp_1" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Amp_2>() , "Amp_2" ) ;

	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Timer>() , "Timer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Timer1>() , "Timer1" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Timer2>() , "Timer2" ) ;
	
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Controller>() , "Controller" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Controller1>() , "Controller1" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Controller2>() , "Controller2" ) ;
	
//	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Source>() , "Source" ) ;
//	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Neuron>() , "Neuron" ) ;

}
