/*******************************************************************
*
*  DESCRIPTION: Atomic Model for logic Timer1
*
*  AUTHOR: Yuri Boiko
*
*  EMAIL: yuri.boiko@rocketmail.com
*
*  DATE: 27/12/2007
*
*******************************************************************/

#ifndef __TIMER1_H
#define __TIMER1_H

#include "atomic.h"     // class Atomic

class Timer1 : public Atomic
{
public:
	Timer1( const string &name = "Timer1" );	//Default constructor
	virtual string className() const ;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );
//	Model &outputFunction( const ExternalMessage & );
	
private:
    Port &m1_inTurnOn;
    Port &m1_inTurnOff;
	Port &out1_clk;
	Port &out1_count;
	Time cycleTime;
	int clk;
	int count;


};	// class Timer

// ** inline ** // 
inline
string Timer1::className() const
{
	return "Timer1" ;
}

#endif   //__TIMER1_H
