/*******************************************************************
*
*  DESCRIPTION: Atomic Model for logic Timer2
*
*  AUTHOR: Yuri Boiko
*
*  EMAIL: yuri.boiko@rocketmail.com
*
*  DATE: 27/12/2007
*
*******************************************************************/

#ifndef __TIMER2_H
#define __TIMER2_H

#include "atomic.h"     // class Atomic

class Timer2 : public Atomic
{
public:
	Timer2( const string &name = "Timer2" );	//Default constructor
	virtual string className() const ;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );
//	Model &outputFunction( const ExternalMessage & );
	
private:
    Port &m2_inTurnOn;
    Port &m2_inTurnOff;
	Port &out2_clk;
	Port &out2_count;
	Time cycleTime;
	int clk;
	int count;


};	// class Timer2

// ** inline ** // 
inline
string Timer2::className() const
{
	return "Timer2" ;
}

#endif   //__TIMER2_H
